/*
 * PersonDAO.java
 *
 * Created on 16. unor 2007, 11:19
 *
 */

package dao;

import dto.PersonDTO;
import entity.Person;
import java.util.List;
import javax.ejb.Remote;

/**
 *
 * @author Ing. Ondrej Fafejta (fafejta.ondrej@gmail.com)
 */
@Remote()
public interface PersonDAO {
    
    public int createPerson(Person person);
    
    public PersonDTO findPersonById(int id);
    
    /**
     * Assign two persons as friends
     * @param id1 first person id
     * @param id2 second person id
     */
    public void assignFriends(int id1, int id2);
    
    public List<PersonDTO> findAllPersons();
    
    public List<PersonDTO> findFriendsByPersonId(int id);
}
