/*
 * PersonDAOBean.java
 *
 * Created on 16. unor 2007, 11:21
 *
 */

package dao;

import dto.PersonDTO;
import entity.Person;
import java.util.List;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;

/**
 *
 * @author Ing. Ondrej Fafejta (fafejta.ondrej@gmail.com)
 */
@Stateless()
public class PersonDAOBean implements PersonDAO{
    @PersistenceContext()
    private EntityManager em;
    
    /** Creates a new instance of PersonDAOBean */
    public PersonDAOBean() {
    }
    
    public int createPerson(Person person){
        em.persist(person);
        return person.getId();
    }
    
    public PersonDTO findPersonById(int id){
        //return em.find(Person.class,id); // ERROR - friends ale LAZY initialized
        // It works
        Number cntOfFriends=(Number) em.createQuery("SELECT COUNT(f) FROM Person res JOIN res.friends f WHERE res.id=:id").
                setParameter("id",id).
                getSingleResult();
        System.out.println("### Count of friends is "+cntOfFriends);


        // It works only if person has at least one friend
        Query query=em.createQuery("SELECT res.id, res.firstname, res.surname, count(f) FROM Person res JOIN res.friends f WHERE res.id=:id GROUP BY res.id, res.firstname, res.surname");
        
        // It does not work - LEFT JOIN instead of JOIN
        //Query query=em.createQuery("SELECT res.id, res.firstname, res.surname, count(f) FROM Person res LEFT JOIN res.friends f WHERE res.id=:id GROUP BY res.id, res.firstname, res.surname");
        
        Object o[]=(Object[]) query.setParameter("id",id).getSingleResult();
        for(int i=0;i<o.length;i++){
            System.out.println(i+": "+o[i]);
        }
        
        return (PersonDTO) em.createQuery("SELECT new dto.PersonDTO(res.id,res.firstname,res.surname) FROM Person res WHERE res.id=:id").
/*
        // why it does not work?
        return (PersonDTO) em.createQuery("SELECT new dto.PersonDTO(res.id,res.firstname,res.surname, count(f)) "+
                "FROM Person res JOIN res.friends f WHERE res.id=:id "+
                "GROUP BY res.id, res.firstname, res.surname").
 */
                setParameter("id",id).
                getSingleResult();
    }
    
    public void assignFriends(int id1, int id2){
        Person p1=myFindPersonById(id1);
        Person p2=myFindPersonById(id2);
        
        p1.getFriends().add(p2);
        p2.getFriends().add(p1);
    }
    
    @SuppressWarnings(value="unchecked")
    public List<PersonDTO> findAllPersons(){
        //return em.createQuery("SELECT new dto.PersonDTO(res.id,res.firstname,res.surname,COUNT(f)) FROM Person res JOIN res.friends f ORDER BY res.surname").
        return em.createQuery("SELECT new dto.PersonDTO(res.id,res.firstname,res.surname) FROM Person res ORDER BY res.surname").
                getResultList();
    }
            
    public List<PersonDTO> findFriendsByPersonId(int id){
        return em.createQuery("SELECT new dto.PersonDTO(res.id,res.firstname,res.surname) FROM Person p JOIN p.friends res WHERE p.id=:id ORDER BY res.surname").
                setParameter("id",id).
                getResultList();
    }
    
    private Person myFindPersonById(int id){
        return em.find(Person.class,id);
    }
}