/*
 * PersonDTO.java
 *
 * Created on 16. unor 2007, 13:45
 *
 */

package dto;

import java.io.Serializable;

/**
 *
 * @author Ing. Ondrej Fafejta (fafejta.ondrej@gmail.com)
 */
public class PersonDTO implements Serializable{
    private int id;
    private String firstname;
    private String surname;
    private Long countOfFriends;
    
    /** Creates a new instance of PersonDTO */
    public PersonDTO() {
    }

    public PersonDTO(int id, String firstname, String surname) {
        setId(id);
        setFirstname(firstname);
        setSurname(surname);
    }
    
    public PersonDTO(int id, String firstname, String surname, Long countOfFriends) {
        this(id,firstname,surname);
        setCountOfFriends(countOfFriends);
    }
    
    public int getId() {
        return id;
    }

    public void setId(int id) {
        this.id = id;
    }

    public String getFirstname() {
        return firstname;
    }

    public void setFirstname(String firstname) {
        this.firstname = firstname;
    }

    public String getSurname() {
        return surname;
    }

    public void setSurname(String surname) {
        this.surname = surname;
    }

    public Long getCountOfFriends() {
        return countOfFriends;
    }

    public void setCountOfFriends(Long countOfFriends) {
        this.countOfFriends = countOfFriends;
    }
    
    @Override()
    public int hashCode() {
        return getId();
    }
    
    @Override()
    public boolean equals(Object object){
        if (object == this) return true;
        if(!(object instanceof PersonDTO)) return false;
        PersonDTO x = (PersonDTO) object;
        if (x.getId() == 0 || getId() == 0) return false;
        return x.getId()==getId();
    }
}
