/*
 * Person.java
 *
 * Created on 16. unor 2007, 11:12
 *
 */

package entity;

import java.io.Serializable;
import java.util.List;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.JoinTable;
import javax.persistence.ManyToMany;
import javax.persistence.Table;

/**
 *
 * @author Ing. Ondrej Fafejta (fafejta.ondrej@gmail.com)
 */
@Entity()
@Table(name = "test_person")
public class Person implements Serializable{
    @Id()
    @Column(name="id")
    private int id;
    
    @Column(name="firstname", nullable=false, length=32)
    private String firstname;
    
    @Column(name="surname", nullable=false, length=32)
    private String surname;
    
    @ManyToMany(fetch=FetchType.LAZY)
    @JoinTable(name="test_person_friend",
            joinColumns=@JoinColumn(name="person_id", referencedColumnName="id"),
            inverseJoinColumns=@JoinColumn(name="friend_id", referencedColumnName="id")
            )
    private List<Person> friends;
    
    /** Creates a new instance of Person */
    public Person() {
    }
    
    /** Creates a new instance of Person */
    public Person(int id, String firstname, String surname) {
        setId(id);
        setFirstname(firstname);
        setSurname(surname);
    }
    
    public int getId() {
        return id;
    }

    public void setId(int id) {
        this.id = id;
    }
    
    public String getFirstname() {
        return firstname;
    }

    public void setFirstname(String firstname) {
        this.firstname = firstname;
    }

    public String getSurname() {
        return surname;
    }

    public void setSurname(String surname) {
        this.surname = surname;
    }

    public List<Person> getFriends() {
        return friends;
    }

    public void setFriends(List<Person> friends) {
        this.friends = friends;
    }
    
    @Override()
    public int hashCode() {
        return getId();
    }
    
    @Override()
    public boolean equals(Object object){
        if (object == this) return true;
        if(!(object instanceof Person)) return false;
        Person x = (Person) object;
        if (x.getId() == 0 || getId() == 0) return false;
        return x.getId()==getId();
    }
}