/*
 * PersonDAOTest.java
 * JUnit based test
 *
 * Created on 16. unor 2007, 12:04
 */

package dao;

import dto.PersonDTO;
import junit.framework.*;
import entity.Person;
import java.util.List;
import javax.naming.InitialContext;
import javax.ejb.Remote;

/**
 *
 * @author fafi
 */
public class PersonDAOTest extends TestCase {
    private PersonDAO instance;
    
    public PersonDAOTest(String testName) throws Exception{
        super(testName);
        InitialContext ctx=new InitialContext();
        instance=(PersonDAO) ctx.lookup(PersonDAO.class.getName());
    }

    protected void setUp() throws Exception {
    }

    protected void tearDown() throws Exception {
    }

/*
    public static Test suite() throws Exception{
        TestSuite suite = new TestSuite();
        suite.addTest(new PersonDAOTest("testFindPersonById"));
        return suite;
    }
*/
    
    /**
     * Test of createPerson method, of class dao.PersonDAO.
     */
    public void testCreatePerson() {
        System.out.println("createPerson");
        
        Person person1 = new Person(1,"First","Tester1");
        int id=instance.createPerson(person1);
        assertEquals(id,person1.getId());
        
        Person person2 = new Person(2,"Second","Tester2");
        id=instance.createPerson(person2);
        assertEquals(id,person2.getId());
        
        Person person3 = new Person(3,"Third","Tester3");
        id=instance.createPerson(person3);
        assertEquals(id,person3.getId());
        
        Person person4 = new Person(4,"Fourth","Tester4");
        id=instance.createPerson(person4);
        assertEquals(id,person4.getId());
    }

    /**
     * Test of assignFriends method, of class dao.PersonDAO.
     */
    public void testAssignFriends() {
        System.out.println("assignFriends");
        
        instance.assignFriends(1,2);
        instance.assignFriends(1,3);
    }
    
    /**
     * Test of findPersonById method, of class dao.PersonDAO.
     */
    public void testFindPersonById() {
        System.out.println("findPersonById");
        
        System.out.println("Person 1 has 2 friends.");
        int id=1;  // person id=1 has two friends
        PersonDTO result = instance.findPersonById(id);
        assertEquals(id, result.getId());
        
        System.out.println("Person 4 has no friends.");
        id=4;      // person id=4 has no friends
        result = instance.findPersonById(id);
        assertEquals(id, result.getId());
    }

    /**
     * Test of findAllPersons method, of class dao.PersonDAO.
     */
    public void testFindAllPersons() {
        System.out.println("findAllPersons");
        
        List<PersonDTO> result = instance.findAllPersons();
        assertTrue(result.size()>0);
    }

    /**
     * Test of findFriendsByPersonId method, of class dao.PersonDAO.
     */
    public void testFindFriendsByPersonId() {
        System.out.println("findFriendsByPersonId");
        
        int id = 1;
        List<PersonDTO> result = instance.findFriendsByPersonId(id);
        assertTrue(result.size()>0);
    }
}
